﻿using Buddy.Wildstar.Game;
using Buddy.Wildstar.Game.Actors;

namespace Agility.Routines
{
    class ESPer_Stun : IAgilityRoutine
    {
        public string Name { get { return "Stun"; } }
        public string Version { get { return "0.1"; } }
        public string Author { get { return "Deathdisguise"; } }

        private Player Me { get { return GameManager.LocalPlayer; } }

        public string Routine()
        {
            if (SpellController.CanCast("Crush", instant: true))
                return "Crush";

            if (SpellController.CanCast("Incapacitate", instant: true))
                return "Incapacitate";

            if (SpellController.CanCast("Shockwave", instant: true))
                return "Shockwave"; 
            
            return null;
        }
    }
}
