﻿using Buddy.Wildstar.Game;
using Buddy.Wildstar.Game.Actors;

namespace Agility.Routines
{
    class Medic_Default : IAgilityRoutine
    {
        // Routine Info.
        public string Name { get { return "Default"; } }
        public string Version { get { return "0.1"; } }
        public string Author { get { return "Deathdisguise"; } }
        public Class Class { get { return Class.Medic; } }

        // Custom Methods.
        private Player Me { get { return GameManager.LocalPlayer; } }

        // Routine.
        public string Routine()
        {

            #region Gadgets

            #region Gadget: Absorb
            if (SpellController.CanCast("Absorb"))
                return "Absorb";
            #endregion

            #region Gadget: Barrier
            if (SpellController.CanCast("Barrier"))
                return "Barrier";
            #endregion

            #region Gadget: Bellow
            if (SpellController.CanCast("Bellow"))
                return "Bellow";
            #endregion

            #region Gadget: Berserk
            if (SpellController.CanCast("Berserk"))
                return "Berserk";
            #endregion

            #region Gadget: Bloodscent
            if (SpellController.CanCast("Bloodscent"))
                return "Bloodscent";
            #endregion

            #region Gadget: Break
            if (SpellController.CanCast("Break"))
                return "Break";
            #endregion

            #region Gadget: Break Free
            if (SpellController.CanCast("Break Free"))
                return "Break Free";
            #endregion

            #region Gadget: Burly
            if (SpellController.CanCast("Burly"))
                return "Burly";
            #endregion

            #region Gadget: Buffer
            if (SpellController.CanCast("Buffer"))
                return "Buffer";
            #endregion

            #region Gadget: Cleanse
            if (SpellController.CanCast("Cleanse"))
                return "Cleanse";
            #endregion

            #region Gadget: Cruelty
            if (SpellController.CanCast("Cruelty"))
                return "Cruelty";
            #endregion

            #region Gadget: Defender
            if (SpellController.CanCast("Defender"))
                return "Defender";
            #endregion

            #region Gadget: Destruction
            if (SpellController.CanCast("Destruction"))
                return "Destruction";
            #endregion

            #region Gadget: Dodger
            if (SpellController.CanCast("Dodger"))
                return "Dodger";
            #endregion

            #region Gadget: Disabler
            if (SpellController.CanCast("Disabler"))
                return "Disabler";
            #endregion

            #region Gadget: Disintegrate
            if (SpellController.CanCast("Disintegrate"))
                return "Disintegrate";
            #endregion

            #region Gadget: Dissolve
            if (SpellController.CanCast("Dissolve"))
                return "Dissolve";
            #endregion

            #region Gadget: E.M.P.
            if (SpellController.CanCast("E.M.P."))
                return "E.M.P.";
            #endregion

            #region Gadget: Encase
            if (SpellController.CanCast("Encase"))
                return "Encase";
            #endregion

            #region Gadget: Erudite
            if (SpellController.CanCast("Erudite"))
                return "Erudite";
            #endregion

            #region Gadget: Exodus Sands
            if (SpellController.CanCast("Exodus Sands"))
                return "Exodus Sands";
            #endregion

            #region Gadget: Ferocity
            if (SpellController.CanCast("Ferocity"))
                return "Ferocity";
            #endregion

            #region Gadget: Finesse
            if (SpellController.CanCast("Finesse"))
                return "Finesse";
            #endregion

            #region Gadget: Fortitude
            if (SpellController.CanCast("Fortitude"))
                return "Fortitude";
            #endregion

            #region Gadget: Giant's Growth
            if (SpellController.CanCast("Giant's Growth"))
                return "Giant's Growth";
            #endregion

            #region Gadget: Guard
            if (SpellController.CanCast("Guard"))
                return "Guard";
            #endregion

            #region Gadget: Guiding Light
            if (SpellController.CanCast("Guiding Light"))
                return "Guiding Light";
            #endregion

            #region Gadget: Heal
            if (SpellController.CanCast("Heal"))
                return "Heal";
            #endregion

            #region Gadget: Healer's Gift
            if (SpellController.CanCast("Healer's Gift"))
                return "Healer's Gift";
            #endregion

            #region Gadget: Intensity
            if (SpellController.CanCast("Intensity"))
                return "Intensity";
            #endregion

            #region Gadget: Juggernaut
            if (SpellController.CanCast("Juggernaut"))
                return "Juggernaut";
            #endregion

            #region Gadget: Mirage Relic
            if (SpellController.CanCast("Mirage Relic"))
                return "Mirage Relic";
            #endregion

            #region Gadget: Mist of the Oasis
            if (SpellController.CanCast("Mist of the Oasis"))
                return "Mist of the Oasis";
            #endregion

            #region Gadget: Parry
            if (SpellController.CanCast("Parry"))
                return "Parry";
            #endregion

            #region Gadget: Power
            if (SpellController.CanCast("Power"))
                return "Power";
            #endregion

            #region Gadget: Power Reserves
            if (SpellController.CanCast("Power Reserves"))
                return "Power Reserves";
            #endregion

            #region Gadget: Powerup
            if (SpellController.CanCast("Powerup"))
                return "Powerup";
            #endregion

            #region Gadget: Punisher
            if (SpellController.CanCast("Punisher"))
                return "Punisher";
            #endregion

            #region Gadget: Precision
            if (SpellController.CanCast("Precision"))
                return "Precision";
            #endregion

            #region Gadget: Protection
            if (SpellController.CanCast("Protection"))
                return "Protection";
            #endregion

            #region Gadget: Protection of the Voidstriker
            if (SpellController.CanCast("Protection of the Voidstriker"))
                return "Protection of the Voidstriker";
            #endregion

            #region Gadget: Pursuant
            if (SpellController.CanCast("Pursuant"))
                return "Pursuant";
            #endregion

            #region Gadget: Rally
            if (SpellController.CanCast("Rally"))
                return "Rally";
            #endregion

            #region Gadget: Recovery
            if (SpellController.CanCast("Recovery"))
                return "Recovery";
            #endregion

            #region Gadget: Reinforce
            if (SpellController.CanCast("Reinforce"))
                return "Reinforce";
            #endregion

            #region Gadget: Replenish
            if (SpellController.CanCast("Replenish"))
                return "Replenish";
            #endregion

            #region Gadget: Reserves
            if (SpellController.CanCast("Reserves"))
                return "Reserves";
            #endregion

            #region Gadget: Salvation
            if (SpellController.CanCast("Salvation"))
                return "Salvation";
            #endregion

            #region Gadget: Savagery
            if (SpellController.CanCast("Savagery"))
                return "Savagery";
            #endregion

            #region Gadget: Second Wind
            if (SpellController.CanCast("Second Wind"))
                return "Second Wind";
            #endregion

            #region Gadget: Severity
            if (SpellController.CanCast("Severity"))
                return "Severity";
            #endregion

            #region Gadget: Shield Charge
            if (SpellController.CanCast("Shield Charge"))
                return "Shield Charge";
            #endregion

            #region Gadget: Shredder
            if (SpellController.CanCast("Shredder"))
                return "Shredder";
            #endregion

            #region Gadget: Stasis
            if (SpellController.CanCast("Stasis"))
                return "Stasis";
            #endregion

            #region Gadget: Tenacity
            if (SpellController.CanCast("Tenacity"))
                return "Tenacity";
            #endregion

            #region Gadget: True Strike
            if (SpellController.CanCast("True Strike"))
                return "True Strike";
            #endregion

            #region Gadget: Unbreakable
            if (SpellController.CanCast("Unbreakable"))
                return "Unbreakable";
            #endregion

            #region Gadget: Unleash
            if (SpellController.CanCast("Unleash"))
                return "Unleash";
            #endregion

            #region Gadget: Vanish
            if (SpellController.CanCast("Vanish"))
                return "Vanish";
            #endregion

            #region Gadget: Wisdom
            if (SpellController.CanCast("Wisdom"))
                return "Wisdom";
            #endregion

            #endregion

            #region Abilities

            #region Dual Shock
            if (SpellController.CanCast("Dual Shock") && Me.HasBuff("Dual Shock"))
                return "Dual Shock";
            #endregion

            #region Empowering Probes
            if (SpellController.CanCast("Empowering Probes"))
                return "Empowering Probes";
            #endregion

            #region Fissure
            if (SpellController.CanCast("Fissure"))
                return "Fissure";
            #endregion

            #region Collider
            if (SpellController.CanCast("Collider"))
                return "Collider";
            #endregion

            #region Atomize
            if (SpellController.CanCast("Atomize") && Me.HasBuff("Atomize"))
                return "Atomize";
            #endregion

            #region Quantum Cascade
            if (SpellController.CanCast("Quantum Cascade"))
                return "Quantum Cascade";
            #endregion

            #region Gamma Rays
            if (SpellController.CanCast("Gamma Rays"))
                return "Gamma Rays";
            #endregion

            #region Energize
            if (SpellController.CanCast("Energize") && Me.InnateResource < 1)
                return "Energize";
            #endregion

            #region Discharge
            if (SpellController.CanCast("Discharge"))
                return "Discharge";
            #endregion

            #endregion

            return null;
        }
    }
}
