﻿using Buddy.Wildstar.Game;
using Buddy.Wildstar.Game.Actors;

namespace Agility.Routines
{
    class Stalker_Stun : IAgilityRoutine
    {
        public string Name { get { return "Stun"; } }
        public string Version { get { return "0.1"; } }
        public string Author { get { return "Deathdisguise"; } }

        private Player Me { get { return GameManager.LocalPlayer; } }

        public string Routine()
        {
            if (SpellController.CanCast("Collapse", instant: true))
                return "Collapse";

            if (SpellController.CanCast("Stagger", instant: true))
                return "Stagger";

            return null;
        }
    }
}
