﻿using Buddy.Wildstar.Game;
using Buddy.Wildstar.Game.Actors;

namespace Agility.Routines
{
    class ESPer_AutoAttack : IAgilityRoutine
    {
        public string Name { get { return "Auto-Attack"; } }
        public string Version { get { return "0.1"; } }
        public string Author { get { return "Deathdisguise"; } }

        private Player Me { get { return GameManager.LocalPlayer; } }

        public string Routine()
        {
            if (SpellController.CanCast("Telekinetic Strike"))
                return "Telekinetic Strike";

            if (SpellController.CanCast("Psychic Frenzy"))
                return "Psychic Frenzy";

            return null;
        }
    }
}
