﻿using Buddy.Wildstar.Game;
using Buddy.Wildstar.Game.Actors;

namespace Agility.Routines
{
    class Stalker_Default : IAgilityRoutine
    {
        // Routine Info.
        public string Name { get { return "Default"; } }
        public string Version { get { return "0.1"; } }
        public string Author { get { return "Deathdisguise"; } }
        public Class Class { get { return Class.Stalker; } }

        // Custom Methods.
        private Player Me { get { return GameManager.LocalPlayer; } }

        // Routine.
        public string Routine()
        {

            #region Gadgets

            #region Gadget: Absorb
            if (SpellController.CanCast("Absorb"))
                return "Absorb";
            #endregion

            #region Gadget: Barrier
            if (SpellController.CanCast("Barrier"))
                return "Barrier";
            #endregion

            #region Gadget: Bellow
            if (SpellController.CanCast("Bellow"))
                return "Bellow";
            #endregion

            #region Gadget: Berserk
            if (SpellController.CanCast("Berserk"))
                return "Berserk";
            #endregion

            #region Gadget: Bloodscent
            if (SpellController.CanCast("Bloodscent"))
                return "Bloodscent";
            #endregion

            #region Gadget: Break
            if (SpellController.CanCast("Break"))
                return "Break";
            #endregion

            #region Gadget: Break Free
            if (SpellController.CanCast("Break Free"))
                return "Break Free";
            #endregion

            #region Gadget: Burly
            if (SpellController.CanCast("Burly"))
                return "Burly";
            #endregion

            #region Gadget: Buffer
            if (SpellController.CanCast("Buffer"))
                return "Buffer";
            #endregion

            #region Gadget: Cleanse
            if (SpellController.CanCast("Cleanse"))
                return "Cleanse";
            #endregion

            #region Gadget: Cruelty
            if (SpellController.CanCast("Cruelty"))
                return "Cruelty";
            #endregion

            #region Gadget: Defender
            if (SpellController.CanCast("Defender"))
                return "Defender";
            #endregion

            #region Gadget: Destruction
            if (SpellController.CanCast("Destruction"))
                return "Destruction";
            #endregion

            #region Gadget: Dodger
            if (SpellController.CanCast("Dodger"))
                return "Dodger";
            #endregion

            #region Gadget: Disabler
            if (SpellController.CanCast("Disabler"))
                return "Disabler";
            #endregion

            #region Gadget: Disintegrate
            if (SpellController.CanCast("Disintegrate"))
                return "Disintegrate";
            #endregion

            #region Gadget: Dissolve
            if (SpellController.CanCast("Dissolve"))
                return "Dissolve";
            #endregion

            #region Gadget: E.M.P.
            if (SpellController.CanCast("E.M.P."))
                return "E.M.P.";
            #endregion

            #region Gadget: Encase
            if (SpellController.CanCast("Encase"))
                return "Encase";
            #endregion

            #region Gadget: Erudite
            if (SpellController.CanCast("Erudite"))
                return "Erudite";
            #endregion

            #region Gadget: Exodus Sands
            if (SpellController.CanCast("Exodus Sands"))
                return "Exodus Sands";
            #endregion

            #region Gadget: Ferocity
            if (SpellController.CanCast("Ferocity"))
                return "Ferocity";
            #endregion

            #region Gadget: Finesse
            if (SpellController.CanCast("Finesse"))
                return "Finesse";
            #endregion

            #region Gadget: Fortitude
            if (SpellController.CanCast("Fortitude"))
                return "Fortitude";
            #endregion

            #region Gadget: Giant's Growth
            if (SpellController.CanCast("Giant's Growth"))
                return "Giant's Growth";
            #endregion

            #region Gadget: Guard
            if (SpellController.CanCast("Guard"))
                return "Guard";
            #endregion

            #region Gadget: Guiding Light
            if (SpellController.CanCast("Guiding Light"))
                return "Guiding Light";
            #endregion

            #region Gadget: Heal
            if (SpellController.CanCast("Heal"))
                return "Heal";
            #endregion

            #region Gadget: Healer's Gift
            if (SpellController.CanCast("Healer's Gift"))
                return "Healer's Gift";
            #endregion

            #region Gadget: Intensity
            if (SpellController.CanCast("Intensity"))
                return "Intensity";
            #endregion

            #region Gadget: Juggernaut
            if (SpellController.CanCast("Juggernaut"))
                return "Juggernaut";
            #endregion

            #region Gadget: Mirage Relic
            if (SpellController.CanCast("Mirage Relic"))
                return "Mirage Relic";
            #endregion

            #region Gadget: Mist of the Oasis
            if (SpellController.CanCast("Mist of the Oasis"))
                return "Mist of the Oasis";
            #endregion

            #region Gadget: Parry
            if (SpellController.CanCast("Parry"))
                return "Parry";
            #endregion

            #region Gadget: Power
            if (SpellController.CanCast("Power"))
                return "Power";
            #endregion

            #region Gadget: Power Reserves
            if (SpellController.CanCast("Power Reserves"))
                return "Power Reserves";
            #endregion

            #region Gadget: Powerup
            if (SpellController.CanCast("Powerup"))
                return "Powerup";
            #endregion

            #region Gadget: Punisher
            if (SpellController.CanCast("Punisher"))
                return "Punisher";
            #endregion

            #region Gadget: Precision
            if (SpellController.CanCast("Precision"))
                return "Precision";
            #endregion

            #region Gadget: Protection
            if (SpellController.CanCast("Protection"))
                return "Protection";
            #endregion

            #region Gadget: Protection of the Voidstriker
            if (SpellController.CanCast("Protection of the Voidstriker"))
                return "Protection of the Voidstriker";
            #endregion

            #region Gadget: Pursuant
            if (SpellController.CanCast("Pursuant"))
                return "Pursuant";
            #endregion

            #region Gadget: Rally
            if (SpellController.CanCast("Rally"))
                return "Rally";
            #endregion

            #region Gadget: Recovery
            if (SpellController.CanCast("Recovery"))
                return "Recovery";
            #endregion

            #region Gadget: Reinforce
            if (SpellController.CanCast("Reinforce"))
                return "Reinforce";
            #endregion

            #region Gadget: Replenish
            if (SpellController.CanCast("Replenish"))
                return "Replenish";
            #endregion

            #region Gadget: Reserves
            if (SpellController.CanCast("Reserves"))
                return "Reserves";
            #endregion

            #region Gadget: Salvation
            if (SpellController.CanCast("Salvation"))
                return "Salvation";
            #endregion

            #region Gadget: Savagery
            if (SpellController.CanCast("Savagery"))
                return "Savagery";
            #endregion

            #region Gadget: Second Wind
            if (SpellController.CanCast("Second Wind"))
                return "Second Wind";
            #endregion

            #region Gadget: Severity
            if (SpellController.CanCast("Severity"))
                return "Severity";
            #endregion

            #region Gadget: Shield Charge
            if (SpellController.CanCast("Shield Charge"))
                return "Shield Charge";
            #endregion

            #region Gadget: Shredder
            if (SpellController.CanCast("Shredder"))
                return "Shredder";
            #endregion

            #region Gadget: Stasis
            if (SpellController.CanCast("Stasis"))
                return "Stasis";
            #endregion

            #region Gadget: Tenacity
            if (SpellController.CanCast("Tenacity"))
                return "Tenacity";
            #endregion

            #region Gadget: True Strike
            if (SpellController.CanCast("True Strike"))
                return "True Strike";
            #endregion

            #region Gadget: Unbreakable
            if (SpellController.CanCast("Unbreakable"))
                return "Unbreakable";
            #endregion

            #region Gadget: Unleash
            if (SpellController.CanCast("Unleash"))
                return "Unleash";
            #endregion

            #region Gadget: Vanish
            if (SpellController.CanCast("Vanish"))
                return "Vanish";
            #endregion

            #region Gadget: Wisdom
            if (SpellController.CanCast("Wisdom"))
                return "Wisdom";
            #endregion

            #endregion

            #region Abilities

            #region Stim Drone
            if (SpellController.CanCast("Stim Drone") && Me.GetActiveCCs().Count > 0)
                return "Stim Drone";
            #endregion

            #region Preparation
            if (SpellController.CanCast("Preparation"))
            {
                // Preparation : Punish and Concussive are on LAS, and both are on cooldown.
                if (SpellController.HasSpell("Punish") && SpellController.HasSpell("Concussive Kicks") &&
                    SpellController.Cooldown("Punish") > 3000 && SpellController.Cooldown("Concussive Kicks") > 3000)
                {
                    if (SpellController.HasAMP("Follow Up"))
                        SpellController.SetStance("Nano Skin: Evasive");

                    return "Preparation";
                }

                // Preparation : Punish and not Concussive are on LAS, and is on cooldown.
                if (SpellController.HasSpell("Punish") && !SpellController.HasSpell("Concussive Kicks") &&
                    SpellController.Cooldown("Punish") > 3000)
                {
                    if (SpellController.HasAMP("Follow Up"))
                        SpellController.SetStance("Nano Skin: Evasive");

                    return "Preparation";
                }
            }
            #endregion

            // Reset stance.
            SpellController.SetStance("Nano Skin: Lethal");

            #region Bloodthirst
            if (SpellController.CanCast("Bloodthirst"))
                return "Bloodthirst";
            #endregion

            #region Nano Skin: Lethal
            // Combat Innate if we have a lot of SP.
            if (SpellController.CanCast("Nano Skin: Lethal") && Me.SuitPower >= 50)
                return "Nano Skin: Lethal";
            #endregion

            #region Impale
            // SP Drain for Punish prep.
            if (SpellController.CanCast("Impale") && SpellController.HasSpell("Punish") && Me.SuitPower >= 30)
                return "Impale";
            #endregion Impale

            #region Analyze Weakness
            if (SpellController.CanCast("Analyze Weakness"))
            {
                // Use with Punish if available.
                if (SpellController.HasSpell("Punish") && Me.HasBuff("Punish") && Me.SuitPower < 30)
                    return "Analyze Weakness";

                // No Punish? Use on CD.
                if (!SpellController.HasSpell("Punish"))
                    return "Analyze Weakness";
            }
            #endregion

            #region Punish
            if (SpellController.CanCast("Punish") && Me.HasBuff("Punish") && Me.SuitPower < 35)
                return "Punish";
            #endregion

            #region Ruin
            if (SpellController.CanCast("Ruin"))
                return "Ruin";
            #endregion

            #region Concussive Kicks
            if (SpellController.CanCast("Concussive Kicks"))
                return "Concussive Kicks";
            #endregion

            #region Neutralize
            if (SpellController.CanCast("Neutralize"))
            {
                // TODO.
            }
            #endregion

            #region Impale
            if (SpellController.CanCast("Impale"))
                return "Impale";
            #endregion

            #region Shred
            if (SpellController.CanCast("Shred"))
                return "Shred";
            #endregion

            #region Whiplash
            if (SpellController.CanCast("Whiplash"))
                return "Whiplash";
            #endregion

            #endregion

            return null;

            #region Cripple
            #endregion

            #region Phlebotomize
            #endregion

            #region Clone
            #endregion

            #region Frenzy
            #endregion

            #region Razor Storm
            #endregion

            #region Steadfast
            #endregion

            #region Decimate
            #endregion

            #region Nano Virus
            #endregion

            #region Razor Disk
            #endregion

            #region Nano Field
            #endregion

            #region Amplification Spike
            #endregion

            #region Nano Dart
            #endregion

            #region Stagger
            #endregion

            //#region Pounce
            //#endregion

            //#region False Retreat
            //#endregion

            //#region Tether Mine
            //#endregion

            #region Tactical Retreat
            #endregion

            #region Collapse
            #endregion

            #region Reaver
            #endregion
        }
    }
}
