﻿using Buddy.Wildstar.Game;
using Buddy.Wildstar.Game.Actors;

namespace Agility.Routines
{
    class Warrior_AutoAttack : IAgilityRoutine
    {
        public string Name { get { return "Auto-Attack"; } }
        public string Version { get { return "0.1"; } }
        public string Author { get { return "Deathdisguise"; } }

        private Player Me { get { return GameManager.LocalPlayer; } }

        public string Routine()
        {
            if (SpellController.CanCast("Relentless Strikes"))
                return "Relentless Strikes";

            if (SpellController.CanCast("Menacing Strike"))
                return "Menacing Strike";

            return null;
        }
    }
}
