﻿using Buddy.Wildstar.Game;
using Buddy.Wildstar.Game.Actors;

namespace Agility.Routines
{
    class Warrior_Tank : IAgilityRoutine
    {
        public string Name { get { return "Auto-Attack"; } }
        public string Version { get { return "1.3"; } }
        public string Author { get { return "Palenie"; } }

        private Player Me { get { return GameManager.LocalPlayer; } }

        public string Routine()
        {
            if (SpellController.CanCast("Power Link") && Me.InnateResource >= 350 && SpellController.BuffCount("Power Link") == 0)
                return "Power Link";

            if (SpellController.CanCast("Breaching Strikes") && Me.HasBuff("Breaching Strikes"))
                return "Breaching Strikes";

            if (SpellController.CanCast("Atomic Spear") && Me.HasBuff("Atomic Spear"))
                return "Atomic Spear";

            if (SpellController.CanCast("Expulsion"))
                return "Expulsion";

            if (SpellController.CanCast("Bolstering Strike") && Me.InnateResource >= 500)
                return "Bolstering Strike";

            if (SpellController.CanCast("Jolt"))
                return "Jolt";

            if (SpellController.CanCast("Shield Burst") && Me.InnateResource >= 500)
                return "Shield Burst";

            if (SpellController.CanCast("Menacing Strike"))
                return "Menacing Strike";

            if (SpellController.CanCast("Defense Grid"))
                return "Defense Grid";

            return null;
        }
    }
}
