﻿using Buddy.Wildstar.Game;
using Buddy.Wildstar.Game.Actors;

namespace Agility.Routines
{
    class Warrior_Taunt : IAgilityRoutine
    {
        public string Name { get { return "Taunt"; } }
        public string Version { get { return "1.3"; } }
        public string Author { get { return "Palenie"; } }

        private Player Me { get { return GameManager.LocalPlayer; } }

        public string Routine()
        {
            if (SpellController.CanCast("Plasma Blast"))
                return "Plasma Blast";

            if (SpellController.CanCast("Atomic Surge"))
                return "Atomic Surge";

            if (SpellController.CanCast("Menacing Strike"))
                return "Menacing Strike";

            if (SpellController.CanCast("Relentless Strikes"))
                return "Relentless Strikes";

            return null;
        }
    }
}